package com.monkeycoder.monkeynes.base;

import java.util.*;

public class MemoryAccessMessage
{
  public static final int MEM_MAIN         = 0;
  public static final int MEM_VIDEO        = 1;
  
  public static final int TYPE_NONE        = 0;
  public static final int TYPE_READ        = 1;
  public static final int TYPE_WRITE       = 2;
  public static final int TYPE_READ_WORD   = 3;
  public static final int TYPE_WRITE_WORD  = 4;  
  public static final int TYPE_READ_RANGE  = 5;
  public static final int TYPE_WRITE_RANGE = 6;
  
  private static final String[] bankName = { "Main", "Video" };
  private static final String[] typeName = { "None", "Read", "Write", "Read Word", "Write Word", "Read Range", "Write Range" };
  
  private int memBank        = MEM_MAIN;
  private int type           = TYPE_NONE;
  private int addrStart      = 0;
  private int addrStop       = 0;
  
  public MemoryAccessMessage( int inMemBank, int inType, int inAddr )
  {
    memBank   = inMemBank;
    type      = inType;
    addrStart = inAddr;
    addrStop  = inAddr;
  }
  
  public MemoryAccessMessage( int inMemBank, int inType, int inAddrStart, int inAddrStop )
  {
    memBank   = inMemBank;
    type      = inType;
    addrStart = inAddrStart;
    addrStop  = inAddrStop;
  }  
  
  public int getMemoryBank()
  {
    return memBank;
  }
  
  public int getType()
  {
    return type;
  }
  
  public int getAddr()
  {
    return addrStart;
  }
  
  public int getAddrStart()
  {
    return addrStart;
  }
  
  public int getAddrStop()
  {
    return addrStop;
  }
  
  public String toString()
  {
    StringBuffer sb = new StringBuffer();
   
    sb.append( "MemoryAccessMessage\n" );
    sb.append( "  Memory Bank:   " );
    sb.append( bankName[getMemoryBank()] );
    sb.append( "\n  Access Type:   " );
    sb.append( typeName[getType()] );
    sb.append( "\n  Start Addr:    " );
    sb.append( getAddrStart() );
    sb.append( "\n  Stop Addr:     " );
    sb.append( getAddrStop() );
    
    return sb.toString();
  }  
  

}