package com.monkeycoder.monkeynes.gui;

import com.monkeycoder.monkeynes.base.*;
import com.monkeycoder.monkeynes.hardware.*;

import java.io.*;
import java.util.*;
import java.awt.event.*;

public class ButtonMapFactory
{
  private Properties prop = new Properties();

  public ButtonMapFactory()
  {
    try
    {
      FileInputStream fis = new FileInputStream( ClassLoader.getSystemResource("monkeynes.ini").getPath() );
      prop.load( fis );
      fis.close();
    }
    catch( IOException ioe )
    {
      DebugLog.log( 1, "Failed to load properties." );
    }  
  }
  
  // Expects NesController.getType() for the map type
  public ButtonMap getButtonMap( int inMapType, int inPort )
  {
    switch( inMapType )
    {
      case NesController.TYPE_JOYPAD:
        return getJoypadMap( inPort );
      default:
        return null;
    }
  }
  
  private ButtonMap getJoypadMap( int inPort )
  {
    ButtonMap bm = new ButtonMap();
    
    bm.addMapping( Integer.parseInt( prop.getProperty( "joypad_" + String.valueOf( inPort ) + "_button_a",          String.valueOf( KeyEvent.VK_X ) ), 10 ),     NesJoypad.BUTTON_A );
    bm.addMapping( Integer.parseInt( prop.getProperty( "joypad_" + String.valueOf( inPort ) + "_button_b",          String.valueOf( KeyEvent.VK_Z ) ), 10 ),     NesJoypad.BUTTON_B );
    bm.addMapping( Integer.parseInt( prop.getProperty( "joypad_" + String.valueOf( inPort ) + "_button_select",     String.valueOf( KeyEvent.VK_S ) ), 10 ),     NesJoypad.BUTTON_SELECT );
    bm.addMapping( Integer.parseInt( prop.getProperty( "joypad_" + String.valueOf( inPort ) + "_button_start",      String.valueOf( KeyEvent.VK_A ) ), 10 ),     NesJoypad.BUTTON_START );
    bm.addMapping( Integer.parseInt( prop.getProperty( "joypad_" + String.valueOf( inPort ) + "_button_dpad_up",    String.valueOf( KeyEvent.VK_UP ) ), 10 ),    NesJoypad.BUTTON_DPAD_UP );
    bm.addMapping( Integer.parseInt( prop.getProperty( "joypad_" + String.valueOf( inPort ) + "_button_dpad_down",  String.valueOf( KeyEvent.VK_DOWN ) ), 10 ),  NesJoypad.BUTTON_DPAD_DOWN );
    bm.addMapping( Integer.parseInt( prop.getProperty( "joypad_" + String.valueOf( inPort ) + "_button_dpad_left",  String.valueOf( KeyEvent.VK_LEFT ) ), 10 ),  NesJoypad.BUTTON_DPAD_LEFT );
    bm.addMapping( Integer.parseInt( prop.getProperty( "joypad_" + String.valueOf( inPort ) + "_button_dpad_right", String.valueOf( KeyEvent.VK_RIGHT ) ), 10 ), NesJoypad.BUTTON_DPAD_RIGHT );
    
    DebugLog.log( bm.toString() );
    
    return bm;    
  }
}