package com.monkeycoder.monkeynes.hardware;

public class CpuState
{
  // Registers
  private CpuRegister pc  = new CpuRegister();       // Program Counter
  private CpuRegister sp  = new CpuRegister();       // Stack Pointer
  private CpuRegister acc = new CpuRegister();       // Accumulator
  private CpuRegister ix  = new CpuRegister();       // X-Index
  private CpuRegister iy  = new CpuRegister();       // Y-Index
  private CpuRegister ps  = new CpuRegister();       // Processor Status
  
  public CpuState()
  {
    // Do nothing...
  }
  
  public CpuState( CpuRegister inPc, CpuRegister inSp, CpuRegister inAcc, CpuRegister inIx, CpuRegister inIy, CpuRegister inPs )
  {                
    setState( inPc, inSp, inAcc, inIx, inIy, inPs );     
  }            
  
  public void setState( CpuRegister inPc, CpuRegister inSp, CpuRegister inAcc, CpuRegister inIx, CpuRegister inIy, CpuRegister inPs )
  {
    pc  = inPc;
    sp  = inSp;
    acc = inAcc;
    ix  = inIx;
    iy  = inIy;
    ps  = inPs;
  }            
  
  // For reading off register values
  public int getProgramCounterValue()
  {
    return pc.getValue();
  }

  public int getStackPointerValue()
  {
    return sp.getValue();
  }

  public int getAccumulatorValue()
  {
    return acc.getValue();
  }

  public int getXIndexValue()
  {
    return ix.getValue();
  }

  public int getYIndexValue()
  {
    return iy.getValue();
  }

  public int getProcessorStatusValue()
  {
    return ps.getValue();
  }     
}                  