package com.monkeycoder.monkeynes.hardware;

import java.util.*;

public class HighResolutionTimer extends Observable
{
  // All clock speeds are in Hz
  private long    clockSpeed  = 0L;
  private double  clockFactor = 0.0;
  private long    lastClock   = 0L;
  private boolean running     = false;
  
  public HighResolutionTimer( long inClockSpeed )
  {
    setClockSpeed( inClockSpeed );  
  }

  public void setClockSpeed( long inClockSpeed )
  {
    clockSpeed  = inClockSpeed;
    clockFactor = (clockSpeed / 1000.0);
  }

  public long getClockSpeed()
  {
    return clockSpeed;
  }
  
  public void startClock()
  {
    lastClock = System.currentTimeMillis();
    running   = true;
  }
  
  public void stopClock()
  {
    running   = false;
  }  
  
  public boolean isRunning()
  {
    return running;
  }
  
  public long getClocksPast()
  {
    long nowClock = System.currentTimeMillis();
    long retClocks = (int)((nowClock - lastClock) * clockFactor);
    
    lastClock = nowClock;
    
    return retClocks;
  }
}