package com.monkeycoder.monkeynes.hardware;

import com.monkeycoder.monkeynes.base.*;

import java.io.*;

public class NesRomLoader
{
  public static NesRom loadRomFile( String inRomFileName )
  {
    NesRom  nr     = new NesRom();
    boolean failed = false;
    
    nr.setRomFileName( inRomFileName );
    
    try
    {    
      FileInputStream fis = new FileInputStream( inRomFileName );
    
      // Determine rom format...
      // For now assume INES format roms
      nr.setRomFormat( NesRom.ROM_FORMAT_INES );
      
      // How big is my file?
      File fileInfo = new File( inRomFileName );
      
      // Grab the header
      nr.setHeaderData( new byte[nr.getRomFormatHeaderSize(nr.getRomFormat())] );
      fis.read( nr.getHeaderData() );
      
      // Grab the rom data
      int[] romData = new int[(int)fileInfo.length() - nr.getRomFormatHeaderSize(nr.getRomFormat())];
      nr.setRomData( romData );

      for( int i = 0; i < romData.length; i++ )
        romData[i] = fis.read();
    }
    catch( IOException ioe )
    {
      DebugLog.log( "IO Exception" );
      failed = true;
    }
        
    if( !failed )
      return nr;
    else
      return null;
  }



}