package com.monkeycoder.monkeynes.hardware;

import com.monkeycoder.monkeynes.base.*;

public class PatternTableTile
{
  private int top[]    = null;  // 8 bytes
  private int bot[]    = null;  // 8 bytes
  
  public PatternTableTile( int[] inTop, int[] inBottom )
  {
    top = inTop;
    bot = inBottom;
  }

  public int getPixelValue( int x, int y )
  {
    // Flip over the X
    x = 7 - x;
    
    int topBit = (top[y] & MathHelper.bitMask[x]) >> x;
    int botBit = (bot[y] & MathHelper.bitMask[x]) >> x;
  
    return (int)((topBit << 1) | (botBit));  
  }

}
