package com.monkeycoder.monkeynes.hardware.mapper;

import com.monkeycoder.monkeynes.hardware.*;

public abstract class MemoryMapper
{
  protected NesMainMemory  mainMem = null;
  protected NesVideoMemory vidMem  = null;
  protected NesRom         rom     = null;
  
  protected MemoryMapper( NesMainMemory inMainMem, NesVideoMemory inVidMem, NesRom inRom )
  {
    mainMem = inMainMem;
    vidMem  = inVidMem;
    rom     = inRom;
  }
  
  public NesMainMemory getMainMemory()
  {
    return mainMem;
  }
  
  public NesVideoMemory getVideoMemory()
  {
    return vidMem;
  }
  
  public NesRom getRom()
  {
    return rom;
  } 
  
  public String toString()
  {
    StringBuffer sb = new StringBuffer();

    sb.append( "[" );
    sb.append( getMapperNumber() );
    sb.append( "] " );
    sb.append( getMapperName() );
    sb.append( " - " );
    sb.append( getMapperDesc() );   
    
    return sb.toString();
  }
  
  public abstract int           getMapperNumber();
  public abstract String        getMapperName();
  public abstract String        getMapperDesc();
  
  public abstract void          powerOn();
  public abstract void          powerOff();
  public abstract void          doCycle();
}